/* Copyright (c) 2014-2016, The Linux Foundation. All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions are
 * met:
 *   * Redistributions of source code must retain the above copyright
 *     notice, this list of conditions and the following disclaimer.
 *   * Redistributions in binary form must reproduce the above
 *     copyright notice, this list of conditions and the following
 *     disclaimer in the documentation and/or other materials provided
 *     with the distribution.
 *   * Neither the name of The Linux Foundation, Inc. nor the names of its
 *     contributors may be used to endorse or promote products derived
 *     from this software without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED "AS IS" AND ANY EXPRESS OR IMPLIED
 * WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES OF
 * MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NON-INFRINGEMENT
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT OWNER OR CONTRIBUTORS
 * BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR
 * BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY,
 * WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE
 * OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
 * IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 */
#ifndef __DEV_VIB_VIBRATOR_H
#define __DEV_VIB_VIBRATOR_H

#define VIB_TIMER_DEFAULT_TIMEOUT   250
#define VIB_LRA_TYPE 0x00
#define VIB_ERM_TYPE 0x01

/* Only copy the definitions that are required for haptic */
#define QPNP_HAP_RATE_CFG1_1c      0x1C
#define QPNP_HAP_RATE_CFG2_04     0x04
#define QPNP_HAP_RATE_CFG1_41       0x41
#define QPNP_HAP_RATE_CFG2_03       0x03

struct qpnp_hap{
    uint8_t hap_rate_cfg1;
    uint8_t hap_rate_cfg2;
    uint8_t vib_type;
};

void vib_turn_on(void);
void vib_turn_off(void);
void vib_timed_turn_on(const uint32_t);
void wait_vib_timeout(void);
void turn_off_vib_early(void);
#endif				/* __DEV_VIB_VIBRATOR_H */
